React UI Components Documentation

ReactJS Scheduler Component

The Scheduler component for ReactJS represents a widget, which displays a set of Appointments in Day, Week, Month, Timeline Day, Timeline Week and Timeline Month views.

Prerequisites

Refer to ReactJS Getting Started before you start with this help topic.

Configuration

The Scheduler component for ReactJS requires the following imports.

 
import React from 'react';
import ReactDOM from 'react-dom';
import JqxScheduler from 'jqwidgets-react/react_jqxscheduler.js';

Then we create our component class. Properties and methods are put as ReactJS props.

  
class App extends React.Component {
render () {
let appointments = new Array();
let appointment1 = {
id: "id1",
description: "George brings projector for presentations.",
location: "",
subject: "Quarterly Project Review Meeting",
calendar: "Room 1",
start: new Date(2016, 10, 23, 9, 0, 0),
end: new Date(2016, 10, 23, 16, 0, 0)
};
let appointment2 = {
id: "id2",
description: "",
location: "",
subject: "IT Group Mtg.",
calendar: "Room 2",
start: new Date(2016, 10, 24, 10, 0, 0),
end: new Date(2016, 10, 24, 15, 0, 0)
};
appointments.push(appointment1);
appointments.push(appointment2);
let source =
{
dataType: "array",
dataFields: [
{ name: 'id', type: 'string' },
{ name: 'description', type: 'string' },
{ name: 'location', type: 'string' },
{ name: 'subject', type: 'string' },
{ name: 'calendar', type: 'string' },
{ name: 'start', type: 'date' },
{ name: 'end', type: 'date' }
],
id: 'id',
localData: appointments
};
let dataAdapter = new $.jqx.dataAdapter(source);
let resources =
{
colorScheme: "scheme05",
dataField: "calendar",
orientation: "horizontal",
source: new $.jqx.dataAdapter(source)
};
let appointmentDataFields =
{
from: "start",
to: "end",
id: "id",
description: "description",
location: "place",
subject: "subject",
resourceId: "calendar"
};
let views =
[
{ type: 'dayView', showWeekends: false },
{ type: 'weekView', showWeekends: false },
{ type: 'monthView' }
];
return (
<JqxScheduler ref='myScheduler'
width={850} height={600} source={dataAdapter} dayNameFormat={'abbr'}
date={new $.jqx.date(2016, 11, 23)} showLegend={true}
view={'weekView'} resources={resources} views={views}
appointmentDataFields={appointmentDataFields}
/>
)
}
}

Finally we render our class in the desired HTML element:

 
ReactDOM.render(<App />, document.getElementById('app'));

Events Methods & Properties

In order to bind to any event, change any property or call any method, we need a reference to the component.
For that we use the ReactJS "ref" Callback Attribute:

 
<JqxScheduler ref='myScheduler' width={850} height={600} source={dataAdapter}...../>

Now, when we have a reference, we need to call the desired event/property/method.
This is done in the componentDidMount() ReactJS Component Lifecycle method.

Events

The cellClick event is triggered when a cell is clicked.

The following example demonstrates how to add an event listener:

Methods & Properties

This is how you call methods & props:

Every component have a method setOptions which accepts a object as an argument. This object contains component settings.

Every component also have a method getOptions which returns a object containing the component settings.

Scheduler Examples

Overview

The following example demonstrates how to create a Scheduler component.

Resources

This following example demonstrates a way to separate the data in two (or more) parts horizontally.

Scheduler API

API Reference of the jQWidgets Scheduler component for React: Scheduler API

Vue UI Components Documentation

Vue Scheduler Component

The Scheduler component for Vue represents a widget displays a set of Appointments in Day, Week, Month, Timeline Day, Timeline Week and Timeline Month views.

Prerequisites

Refer to Vue Getting Started before you start with this help topic.

Configuration

After you have created your App.vue file, here is how you should structure it:

The Scheduler component for Vue requires the following import:

import JqxScheduler from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxscheduler.vue';

Add the jqxScheduler component to the components section of the the Vue class:

 components: {
JqxScheduler
},

Template

The App.vue has a <template> structural tag where we determine the application structure. There we will also set the tags for the new components - <JqxScheduler/>

<template>
<JqxScheduler :width="width" :height="height" :source="dataAdapter"
:date="date" :view="view" :views="views"
:appointmentDataFields="appointmentDataFields">
</JqxScheduler>
</template>

Properties

The properties of the <JqxScheduler/> component are defined in the data member of the Vue class. We should put them in the return object of the data function:

data: function () {
return {
width: 800,
height: 600,
date: new jqx.date(2016, 11, 23),
appointmentDataFields:
{
from: "start",
to: "end",
id: "id",
description: "about",
location: "address",
subject: "name",
style: "style",
status: "status"
},
views:
[
{ type: "dayView", showWeekends: false, timeRuler: { hidden: false } },
{
type: "weekView", workTime:
{
fromDayOfWeek: 1,
toDayOfWeek: 5,
fromHour: 7,
toHour: 19
}
}
],
view: 'weekView',
dataAdapter: new jqx.dataAdapter(this.source)
}
}

Events

The events in Vue are set as an attribute with @ prefix, for example:

<JqxScheduler @viewChange="onViewChanged()"
:width="width" :height="height" :source="dataAdapter"
:date="date" :view="view" :views="views"
:appointmentDataFields="appointmentDataFields">
</JqxScheduler>

All events that are bound to a component are implemented in the methods member of the Vue class.

methods: {
onViewChanged: function () {
// Do something...
}
}

Methods

To use a component's method we should have its reference. In Vue we refer to a component by the special $refs property. Before that we need to add the desired name reference to that component:

<JqxScheduler ref="scheduler"></JqxScheduler>

Here how you can use a component's method:

this.$refs.scheduler.ensureAppointmentVisible();

If we want to add additional methods we should also implement them in the methods member.

In case we need to do some precalculation or something else before the components are rendered, we should use the beforeCreate member. In this case:

If you have followed the above steps, you App.vue file would look like this:

App.vue:

Scheduler Example

Run Code

Angular UI Components Documentation

Angular Scheduler Component

The Scheduler component for Angular represents a widget displays a set of Appointments in Day, Week, Month, Timeline Day, Timeline Week and Timeline Month views.

1. Installation

The easiest way to get started with jQWidgets UI for Angular is to use the Angular CLI Tool. To scaffold your project structure, follow its installation instructions.

npm install -g @angular/cli
ng new jqwidgets-project
cd jqwidgets-project

Install jQWidgets

jQWidgets Angular UI comes packaged with Angular CLI schematics to make creating Angular applications easier. Schematics are included with both @angular/cdk and jqwidgets-ng. Once you install the npm packages, they will be available through the Angular CLI.

Angular CLI supports the addition of packages through the ng add command. The ng add command provides faster and more user-friendly package installation. To install the jQWidgets UI for Angular package, use ng add and add the name of the NPM package:

ng add jqwidgets-ng

Alternatively, you can use the standard installation (Manual Setup)

jQWidgets UI for Angular is distributed as jqwidgets-ng NPM package

  1. Download and install the package.
    npm install jqwidgets-ng
  2. Adding CSS reference

    The following CSS file is available in ../node_modules/jqwidgets-ng/ package folder. This can be referenced in [src/styles.css] using following code.

    @import 'jqwidgets-ng/jqwidgets/styles/jqx.base.css';

    Another way to achieve the same is to edit the angular.json file and in the styles add the style.

    "styles": [
    	"node_modules/jqwidgets-ng/jqwidgets/styles/jqx.base.css"
    ]
    

2. Add the HTML for jQWidgets component in src/app/app.component.html

app.component.html


<jqxScheduler [theme]="'fluent'" #schedulerReference
              [date]="date" [width]="800" [height]="600" [source]="dataAdapter" [showLegend]="true" [view]="'weekView'"
              [appointmentDataFields]="appointmentDataFields" [resources]="resources" [views]="views">
</jqxScheduler>	

3. Setup Component Logic

app.component.ts


import { Component, ViewChild, AfterViewInit } from '@angular/core';


import { jqxSchedulerModule, jqxSchedulerComponent } from 'jqwidgets-ng/jqxscheduler';
@Component({
    selector: 'app-root',
    imports: [jqxSchedulerModule],
    standalone: true,
    templateUrl: './app.component.html'
})

export class AppComponent implements AfterViewInit {
    @ViewChild('schedulerReference') scheduler: jqxSchedulerComponent;

    ngAfterViewInit(): void {
        this.scheduler.ensureAppointmentVisible('id1');
    }

    getWidth(): any {
        if (document.body.offsetWidth < 850) {
            return '90%';
        }

        return 850;
    }

    generateAppointments(): any {
        let appointments = new Array();
        let appointment1 = {
            id: "id1",
            description: "George brings projector for presentations.",
            location: "",
            subject: "Quarterly Project Review Meeting",
            calendar: "Room 1",
            start: new Date(2025, 10, 23, 9, 0, 0),
            end: new Date(2025, 10, 23, 16, 0, 0)
        };
        let appointment2 = {
            id: "id2",
            description: "",
            location: "",
            subject: "IT Group Mtg.",
            calendar: "Room 2",
            start: new Date(2025, 10, 24, 10, 0, 0),
            end: new Date(2025, 10, 24, 15, 0, 0)
        };
        let appointment3 = {
            id: "id3",
            description: "",
            location: "",
            subject: "Course Social Media",
            calendar: "Room 3",
            start: new Date(2025, 10, 27, 11, 0, 0),
            end: new Date(2025, 10, 27, 13, 0, 0)
        };
        let appointment4 = {
            id: "id4",
            description: "",
            location: "",
            subject: "New Projects Planning",
            calendar: "Room 2",
            start: new Date(2025, 10, 23, 16, 0, 0),
            end: new Date(2025, 10, 23, 18, 0, 0)
        };
        let appointment5 = {
            id: "id5",
            description: "",
            location: "",
            subject: "Interview with James",
            calendar: "Room 1",
            start: new Date(2025, 10, 25, 15, 0, 0),
            end: new Date(2025, 10, 25, 17, 0, 0)
        };
        let appointment6 = {
            id: "id6",
            description: "",
            location: "",
            subject: "Interview with Nancy",
            calendar: "Room 4",
            start: new Date(2025, 10, 26, 14, 0, 0),
            end: new Date(2025, 10, 26, 16, 0, 0)
        };
        appointments.push(appointment1);
        appointments.push(appointment2);
        appointments.push(appointment3);
        appointments.push(appointment4);
        appointments.push(appointment5);
        appointments.push(appointment6);

        return appointments;
    };

    source: any =
        {
            dataType: "array",
            dataFields: [
                { name: 'id', type: 'string' },
                { name: 'description', type: 'string' },
                { name: 'location', type: 'string' },
                { name: 'subject', type: 'string' },
                { name: 'calendar', type: 'string' },
                { name: 'start', type: 'date' },
                { name: 'end', type: 'date' }
            ],
            id: 'id',
            localData: this.generateAppointments()
        };

    dataAdapter: any = new jqx.dataAdapter(this.source);
    date: any = new jqx.date(2016, 11, 23);

    appointmentDataFields: any =
        {
            from: "start",
            to: "end",
            id: "id",
            description: "description",
            location: "location",
            subject: "subject",
            resourceId: "calendar"
        };

    resources: any =
        {
            colorScheme: "scheme05",
            dataField: "calendar",
            source: new jqx.dataAdapter(this.source)
        };

    views: any[] =
        [
            'dayView',
            'weekView',
            'monthView'
        ];
}

Summary

jQWidgets UI for Angular provides an easy way to integrate robust UI components into your Angular project. By using either the ng add command or manual setup, you can quickly get started. Once the setup is complete, you can add the desired jQWidgets components and configure them in your Angular components to match your application requirements.

Scheduler API

API Reference of the jQWidgets Scheduler component for Angular: Scheduler API